<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import Leaf from "./_design_3_leaf.svelte";

  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 80, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  let weekData = Array(5).fill([])

  // vars
  export let data = null;
  export let city = "";
  const startDate = new Date("December 1, 2014 00:00:00");
  const dayOfWeek = startDate.getDay();
  const weeks = [1, 2, 3, 4, 5];

  // hourly_electricity_vs_gas_december.json
  onMount(async () => {
    data = await json("/data/hourly_electricity_vs_gas_december.json");
    console.log(data);
    city = data[0].city;
    console.log("city: ", city)
    console.log(startDate);
    console.log("day of week: ", dayOfWeek)
    weeks.forEach((item) => {
      weekData[item] = getWeek(item, data)
    })
  });


  function getWeek(weekNb, data) {
    console.log("getWeek", weekNb);
    if (!data) return data;
    let days = [1, 2, 3, 4, 5, 6, 7].map(x => x + ((weekNb-1)*7));
    console.log("days", days);
    return data.filter(function (el) {
      return days.includes(el.day);
    })
  }

</script>

<svg {width} {height}>
  <g>
    <line x1="{width/2}" y1="{margin.top+90}" x2="{width/2}" y2="{height-margin.top-margin.bottom}" stroke="black"/>
    </g>
    <Leaf data={weekData[5]} week={5} dX={240} dY={80} dRot={-30} scaleY={1}/>
    <Leaf data={weekData[4]} week={4} dX={260} dY={160} dRot={-150} scaleY={-1}/>
    <Leaf data={weekData[3]} week={3} dX={240} dY={240} dRot={-30} scaleY={1}/>
    <Leaf data={weekData[2]} week={2} dX={260} dY={320} dRot={-150} scaleY={-1}/>
    <Leaf data={weekData[1]} week={1} dX={240} dY={400} dRot={-30} scaleY={1}/>
    <g>
      <text x="{width/2}" y="{height-margin.bottom+20}" text-anchor="middle" font-size="24px">{city}</text>
      <text x="{width/2}" y="{height-margin.bottom+50}" text-anchor="middle" font-size="16px">(December (/August?) 2014)</text>
    </g>
</svg>

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
</style>
